//
//  ELMeatProbeScreenBoxBleBBQParamModel.h
//  AILinkComponentMeatProbe
//
//  Created by Larry Zhang on 2024/2/26.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface ELMeatProbeScreenBoxBleBBQParamModel : NSObject

//生成时间
@property (nonatomic, assign) NSTimeInterval timestamp;

@property (nonatomic, strong) NSData *macData;
@property (nonatomic, copy, readonly) NSString *macString;

@property (nonatomic, assign) UInt8 state; //State: 0x00:未开始,结束任务时,状态切为未开始,未开始状态时,不需要判定其他参数 0x01:已开始,开始任务时,状态切位已开始

@property (nonatomic, assign) UInt8 foodType; //食物类型

@property (nonatomic, assign) UInt16 targetTemperatureRaw_C; //食物目标温度：℃
@property (nonatomic, assign, readonly) NSInteger targetTemperature_C;
@property (nonatomic, assign) UInt16 targetTemperatureRaw_F; //食物目标温度：℉
@property (nonatomic, assign, readonly) NSInteger targetTemperature_F;

@property (nonatomic, assign) UInt16 ambientMinTemperatureRaw_C; //炉温目标下限：℃
@property (nonatomic, assign, readonly) NSInteger ambientMinTemperature_C;
@property (nonatomic, assign) UInt16 ambientMinTemperatureRaw_F; //炉温目标下限：℉
@property (nonatomic, assign, readonly) NSInteger ambientMinTemperature_F;

@property (nonatomic, assign) UInt16 ambientMaxTemperatureRaw_C; //炉温目标上限：℃
@property (nonatomic, assign, readonly) NSInteger ambientMaxTemperature_C;
@property (nonatomic, assign) UInt16 ambientMaxTemperatureRaw_F; //炉温目标上限：℉
@property (nonatomic, assign, readonly) NSInteger ambientMaxTemperature_F;

@property (nonatomic, assign) float alarmTemperaturePercent; //提醒温度对目标温度百分比 0~1.0

@property (nonatomic, assign) UInt32 cookingId; //CookingID

@property (nonatomic, assign) UInt32 workTime; //任务已运行时间,单位s

@property (nonatomic, assign) UInt32 timerCount; //计时剩余时间(秒)

@property (nonatomic, assign) UInt8 foodRawness; //食物熟度 (maturityID)

@property (nonatomic, strong) NSData *remarkData;

- (void)clearAll;

- (void)cookDone;

- (NSData *)dataValue;

- (NSString *)remark;
- (NSString *)setRemark:(NSString *)remark;

@end

NS_ASSUME_NONNULL_END
